//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private AARCBigBenda[] cacheAARCBigBenda = null;
        private AARCDonchain[] cacheAARCDonchain = null;
        private AARCEmafan[] cacheAARCEmafan = null;
        private AARCMacDiv[] cacheAARCMacDiv = null;
        private AARCNR10[] cacheAARCNR10 = null;
        private AARCPinBar[] cacheAARCPinBar = null;
        private AARCRetracer[] cacheAARCRetracer = null;
        private AARCSQ1001[] cacheAARCSQ1001 = null;
        private AARCTimeOfDay[] cacheAARCTimeOfDay = null;

        private static AARCBigBenda checkAARCBigBenda = new AARCBigBenda();
        private static AARCDonchain checkAARCDonchain = new AARCDonchain();
        private static AARCEmafan checkAARCEmafan = new AARCEmafan();
        private static AARCMacDiv checkAARCMacDiv = new AARCMacDiv();
        private static AARCNR10 checkAARCNR10 = new AARCNR10();
        private static AARCPinBar checkAARCPinBar = new AARCPinBar();
        private static AARCRetracer checkAARCRetracer = new AARCRetracer();
        private static AARCSQ1001 checkAARCSQ1001 = new AARCSQ1001();
        private static AARCTimeOfDay checkAARCTimeOfDay = new AARCTimeOfDay();

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public AARCBigBenda AARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return AARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public AARCBigBenda AARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            if (cacheAARCBigBenda != null)
                for (int idx = 0; idx < cacheAARCBigBenda.Length; idx++)
                    if (cacheAARCBigBenda[idx].Countback == countback && Math.Abs(cacheAARCBigBenda[idx].Countbackoffset - countbackoffset) <= double.Epsilon && cacheAARCBigBenda[idx].Divergenceon == divergenceon && cacheAARCBigBenda[idx].FTPeriod == fTPeriod && cacheAARCBigBenda[idx].Seperation == seperation && cacheAARCBigBenda[idx].Textbb == textbb && cacheAARCBigBenda[idx].Texton == texton && cacheAARCBigBenda[idx].Thistimeperiodon == thistimeperiodon && cacheAARCBigBenda[idx].TimeFrame == timeFrame && Math.Abs(cacheAARCBigBenda[idx].Zerooffset - zerooffset) <= double.Epsilon && cacheAARCBigBenda[idx].Zzstrategyuse == zzstrategyuse && cacheAARCBigBenda[idx].EqualsInput(input))
                        return cacheAARCBigBenda[idx];

            lock (checkAARCBigBenda)
            {
                checkAARCBigBenda.Countback = countback;
                countback = checkAARCBigBenda.Countback;
                checkAARCBigBenda.Countbackoffset = countbackoffset;
                countbackoffset = checkAARCBigBenda.Countbackoffset;
                checkAARCBigBenda.Divergenceon = divergenceon;
                divergenceon = checkAARCBigBenda.Divergenceon;
                checkAARCBigBenda.FTPeriod = fTPeriod;
                fTPeriod = checkAARCBigBenda.FTPeriod;
                checkAARCBigBenda.Seperation = seperation;
                seperation = checkAARCBigBenda.Seperation;
                checkAARCBigBenda.Textbb = textbb;
                textbb = checkAARCBigBenda.Textbb;
                checkAARCBigBenda.Texton = texton;
                texton = checkAARCBigBenda.Texton;
                checkAARCBigBenda.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkAARCBigBenda.Thistimeperiodon;
                checkAARCBigBenda.TimeFrame = timeFrame;
                timeFrame = checkAARCBigBenda.TimeFrame;
                checkAARCBigBenda.Zerooffset = zerooffset;
                zerooffset = checkAARCBigBenda.Zerooffset;
                checkAARCBigBenda.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCBigBenda.Zzstrategyuse;

                if (cacheAARCBigBenda != null)
                    for (int idx = 0; idx < cacheAARCBigBenda.Length; idx++)
                        if (cacheAARCBigBenda[idx].Countback == countback && Math.Abs(cacheAARCBigBenda[idx].Countbackoffset - countbackoffset) <= double.Epsilon && cacheAARCBigBenda[idx].Divergenceon == divergenceon && cacheAARCBigBenda[idx].FTPeriod == fTPeriod && cacheAARCBigBenda[idx].Seperation == seperation && cacheAARCBigBenda[idx].Textbb == textbb && cacheAARCBigBenda[idx].Texton == texton && cacheAARCBigBenda[idx].Thistimeperiodon == thistimeperiodon && cacheAARCBigBenda[idx].TimeFrame == timeFrame && Math.Abs(cacheAARCBigBenda[idx].Zerooffset - zerooffset) <= double.Epsilon && cacheAARCBigBenda[idx].Zzstrategyuse == zzstrategyuse && cacheAARCBigBenda[idx].EqualsInput(input))
                            return cacheAARCBigBenda[idx];

                AARCBigBenda indicator = new AARCBigBenda();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Countback = countback;
                indicator.Countbackoffset = countbackoffset;
                indicator.Divergenceon = divergenceon;
                indicator.FTPeriod = fTPeriod;
                indicator.Seperation = seperation;
                indicator.Textbb = textbb;
                indicator.Texton = texton;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeFrame = timeFrame;
                indicator.Zerooffset = zerooffset;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCBigBenda[] tmp = new AARCBigBenda[cacheAARCBigBenda == null ? 1 : cacheAARCBigBenda.Length + 1];
                if (cacheAARCBigBenda != null)
                    cacheAARCBigBenda.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCBigBenda = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public AARCDonchain AARCDonchain(int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return AARCDonchain(Input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public AARCDonchain AARCDonchain(Data.IDataSeries input, int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            if (cacheAARCDonchain != null)
                for (int idx = 0; idx < cacheAARCDonchain.Length; idx++)
                    if (cacheAARCDonchain[idx].PeriodA == periodA && cacheAARCDonchain[idx].PeriodB == periodB && cacheAARCDonchain[idx].PeriodC == periodC && cacheAARCDonchain[idx].PeriodD == periodD && cacheAARCDonchain[idx].PeriodE == periodE && cacheAARCDonchain[idx].EqualsInput(input))
                        return cacheAARCDonchain[idx];

            lock (checkAARCDonchain)
            {
                checkAARCDonchain.PeriodA = periodA;
                periodA = checkAARCDonchain.PeriodA;
                checkAARCDonchain.PeriodB = periodB;
                periodB = checkAARCDonchain.PeriodB;
                checkAARCDonchain.PeriodC = periodC;
                periodC = checkAARCDonchain.PeriodC;
                checkAARCDonchain.PeriodD = periodD;
                periodD = checkAARCDonchain.PeriodD;
                checkAARCDonchain.PeriodE = periodE;
                periodE = checkAARCDonchain.PeriodE;

                if (cacheAARCDonchain != null)
                    for (int idx = 0; idx < cacheAARCDonchain.Length; idx++)
                        if (cacheAARCDonchain[idx].PeriodA == periodA && cacheAARCDonchain[idx].PeriodB == periodB && cacheAARCDonchain[idx].PeriodC == periodC && cacheAARCDonchain[idx].PeriodD == periodD && cacheAARCDonchain[idx].PeriodE == periodE && cacheAARCDonchain[idx].EqualsInput(input))
                            return cacheAARCDonchain[idx];

                AARCDonchain indicator = new AARCDonchain();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.PeriodA = periodA;
                indicator.PeriodB = periodB;
                indicator.PeriodC = periodC;
                indicator.PeriodD = periodD;
                indicator.PeriodE = periodE;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCDonchain[] tmp = new AARCDonchain[cacheAARCDonchain == null ? 1 : cacheAARCDonchain.Length + 1];
                if (cacheAARCDonchain != null)
                    cacheAARCDonchain.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCDonchain = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public AARCEmafan AARCEmafan(int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return AARCEmafan(Input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public AARCEmafan AARCEmafan(Data.IDataSeries input, int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            if (cacheAARCEmafan != null)
                for (int idx = 0; idx < cacheAARCEmafan.Length; idx++)
                    if (cacheAARCEmafan[idx].Fema1 == fema1 && cacheAARCEmafan[idx].Fema2 == fema2 && cacheAARCEmafan[idx].Fema3 == fema3 && cacheAARCEmafan[idx].Fema4 == fema4 && cacheAARCEmafan[idx].Fema5 == fema5 && cacheAARCEmafan[idx].Fema6 == fema6 && cacheAARCEmafan[idx].Fema7 == fema7 && cacheAARCEmafan[idx].Risingon == risingon && cacheAARCEmafan[idx].Zzstrategyuse == zzstrategyuse && cacheAARCEmafan[idx].EqualsInput(input))
                        return cacheAARCEmafan[idx];

            lock (checkAARCEmafan)
            {
                checkAARCEmafan.Fema1 = fema1;
                fema1 = checkAARCEmafan.Fema1;
                checkAARCEmafan.Fema2 = fema2;
                fema2 = checkAARCEmafan.Fema2;
                checkAARCEmafan.Fema3 = fema3;
                fema3 = checkAARCEmafan.Fema3;
                checkAARCEmafan.Fema4 = fema4;
                fema4 = checkAARCEmafan.Fema4;
                checkAARCEmafan.Fema5 = fema5;
                fema5 = checkAARCEmafan.Fema5;
                checkAARCEmafan.Fema6 = fema6;
                fema6 = checkAARCEmafan.Fema6;
                checkAARCEmafan.Fema7 = fema7;
                fema7 = checkAARCEmafan.Fema7;
                checkAARCEmafan.Risingon = risingon;
                risingon = checkAARCEmafan.Risingon;
                checkAARCEmafan.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCEmafan.Zzstrategyuse;

                if (cacheAARCEmafan != null)
                    for (int idx = 0; idx < cacheAARCEmafan.Length; idx++)
                        if (cacheAARCEmafan[idx].Fema1 == fema1 && cacheAARCEmafan[idx].Fema2 == fema2 && cacheAARCEmafan[idx].Fema3 == fema3 && cacheAARCEmafan[idx].Fema4 == fema4 && cacheAARCEmafan[idx].Fema5 == fema5 && cacheAARCEmafan[idx].Fema6 == fema6 && cacheAARCEmafan[idx].Fema7 == fema7 && cacheAARCEmafan[idx].Risingon == risingon && cacheAARCEmafan[idx].Zzstrategyuse == zzstrategyuse && cacheAARCEmafan[idx].EqualsInput(input))
                            return cacheAARCEmafan[idx];

                AARCEmafan indicator = new AARCEmafan();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fema1 = fema1;
                indicator.Fema2 = fema2;
                indicator.Fema3 = fema3;
                indicator.Fema4 = fema4;
                indicator.Fema5 = fema5;
                indicator.Fema6 = fema6;
                indicator.Fema7 = fema7;
                indicator.Risingon = risingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCEmafan[] tmp = new AARCEmafan[cacheAARCEmafan == null ? 1 : cacheAARCEmafan.Length + 1];
                if (cacheAARCEmafan != null)
                    cacheAARCEmafan.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCEmafan = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public AARCMacDiv AARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return AARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public AARCMacDiv AARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            if (cacheAARCMacDiv != null)
                for (int idx = 0; idx < cacheAARCMacDiv.Length; idx++)
                    if (cacheAARCMacDiv[idx].Afast == afast && cacheAARCMacDiv[idx].Aslow == aslow && cacheAARCMacDiv[idx].Asmooth == asmooth && cacheAARCMacDiv[idx].MacdCountback == macdCountback && cacheAARCMacDiv[idx].Macdtrigtext == macdtrigtext && cacheAARCMacDiv[idx].Seperation == seperation && cacheAARCMacDiv[idx].Thistimeperiodon == thistimeperiodon && cacheAARCMacDiv[idx].TimeFrame == timeFrame && cacheAARCMacDiv[idx].Timmingzone == timmingzone && cacheAARCMacDiv[idx].Wordingon == wordingon && cacheAARCMacDiv[idx].Zzstrategyuse == zzstrategyuse && cacheAARCMacDiv[idx].EqualsInput(input))
                        return cacheAARCMacDiv[idx];

            lock (checkAARCMacDiv)
            {
                checkAARCMacDiv.Afast = afast;
                afast = checkAARCMacDiv.Afast;
                checkAARCMacDiv.Aslow = aslow;
                aslow = checkAARCMacDiv.Aslow;
                checkAARCMacDiv.Asmooth = asmooth;
                asmooth = checkAARCMacDiv.Asmooth;
                checkAARCMacDiv.MacdCountback = macdCountback;
                macdCountback = checkAARCMacDiv.MacdCountback;
                checkAARCMacDiv.Macdtrigtext = macdtrigtext;
                macdtrigtext = checkAARCMacDiv.Macdtrigtext;
                checkAARCMacDiv.Seperation = seperation;
                seperation = checkAARCMacDiv.Seperation;
                checkAARCMacDiv.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkAARCMacDiv.Thistimeperiodon;
                checkAARCMacDiv.TimeFrame = timeFrame;
                timeFrame = checkAARCMacDiv.TimeFrame;
                checkAARCMacDiv.Timmingzone = timmingzone;
                timmingzone = checkAARCMacDiv.Timmingzone;
                checkAARCMacDiv.Wordingon = wordingon;
                wordingon = checkAARCMacDiv.Wordingon;
                checkAARCMacDiv.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCMacDiv.Zzstrategyuse;

                if (cacheAARCMacDiv != null)
                    for (int idx = 0; idx < cacheAARCMacDiv.Length; idx++)
                        if (cacheAARCMacDiv[idx].Afast == afast && cacheAARCMacDiv[idx].Aslow == aslow && cacheAARCMacDiv[idx].Asmooth == asmooth && cacheAARCMacDiv[idx].MacdCountback == macdCountback && cacheAARCMacDiv[idx].Macdtrigtext == macdtrigtext && cacheAARCMacDiv[idx].Seperation == seperation && cacheAARCMacDiv[idx].Thistimeperiodon == thistimeperiodon && cacheAARCMacDiv[idx].TimeFrame == timeFrame && cacheAARCMacDiv[idx].Timmingzone == timmingzone && cacheAARCMacDiv[idx].Wordingon == wordingon && cacheAARCMacDiv[idx].Zzstrategyuse == zzstrategyuse && cacheAARCMacDiv[idx].EqualsInput(input))
                            return cacheAARCMacDiv[idx];

                AARCMacDiv indicator = new AARCMacDiv();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Afast = afast;
                indicator.Aslow = aslow;
                indicator.Asmooth = asmooth;
                indicator.MacdCountback = macdCountback;
                indicator.Macdtrigtext = macdtrigtext;
                indicator.Seperation = seperation;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeFrame = timeFrame;
                indicator.Timmingzone = timmingzone;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCMacDiv[] tmp = new AARCMacDiv[cacheAARCMacDiv == null ? 1 : cacheAARCMacDiv.Length + 1];
                if (cacheAARCMacDiv != null)
                    cacheAARCMacDiv.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCMacDiv = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public AARCNR10 AARCNR10(string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return AARCNR10(Input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public AARCNR10 AARCNR10(Data.IDataSeries input, string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            if (cacheAARCNR10 != null)
                for (int idx = 0; idx < cacheAARCNR10.Length; idx++)
                    if (cacheAARCNR10[idx].Nr10text == nr10text && cacheAARCNR10[idx].Period == period && cacheAARCNR10[idx].Seperation == seperation && cacheAARCNR10[idx].Wordingon == wordingon && cacheAARCNR10[idx].Zstrategyuse == zstrategyuse && cacheAARCNR10[idx].EqualsInput(input))
                        return cacheAARCNR10[idx];

            lock (checkAARCNR10)
            {
                checkAARCNR10.Nr10text = nr10text;
                nr10text = checkAARCNR10.Nr10text;
                checkAARCNR10.Period = period;
                period = checkAARCNR10.Period;
                checkAARCNR10.Seperation = seperation;
                seperation = checkAARCNR10.Seperation;
                checkAARCNR10.Wordingon = wordingon;
                wordingon = checkAARCNR10.Wordingon;
                checkAARCNR10.Zstrategyuse = zstrategyuse;
                zstrategyuse = checkAARCNR10.Zstrategyuse;

                if (cacheAARCNR10 != null)
                    for (int idx = 0; idx < cacheAARCNR10.Length; idx++)
                        if (cacheAARCNR10[idx].Nr10text == nr10text && cacheAARCNR10[idx].Period == period && cacheAARCNR10[idx].Seperation == seperation && cacheAARCNR10[idx].Wordingon == wordingon && cacheAARCNR10[idx].Zstrategyuse == zstrategyuse && cacheAARCNR10[idx].EqualsInput(input))
                            return cacheAARCNR10[idx];

                AARCNR10 indicator = new AARCNR10();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Nr10text = nr10text;
                indicator.Period = period;
                indicator.Seperation = seperation;
                indicator.Wordingon = wordingon;
                indicator.Zstrategyuse = zstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCNR10[] tmp = new AARCNR10[cacheAARCNR10 == null ? 1 : cacheAARCNR10.Length + 1];
                if (cacheAARCNR10 != null)
                    cacheAARCNR10.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCNR10 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public AARCPinBar AARCPinBar(int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return AARCPinBar(Input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public AARCPinBar AARCPinBar(Data.IDataSeries input, int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            if (cacheAARCPinBar != null)
                for (int idx = 0; idx < cacheAARCPinBar.Length; idx++)
                    if (cacheAARCPinBar[idx].Barcount == barcount && cacheAARCPinBar[idx].Bearpintext == bearpintext && Math.Abs(cacheAARCPinBar[idx].Bodysize - bodysize) <= double.Epsilon && cacheAARCPinBar[idx].Bullpintext == bullpintext && cacheAARCPinBar[idx].Seperation == seperation && cacheAARCPinBar[idx].Thistimeperiodon == thistimeperiodon && cacheAARCPinBar[idx].TimeperiodA == timeperiodA && cacheAARCPinBar[idx].TimeperiodB == timeperiodB && cacheAARCPinBar[idx].Timeperiodon == timeperiodon && cacheAARCPinBar[idx].Wordingon == wordingon && cacheAARCPinBar[idx].Zzstrategyuse == zzstrategyuse && cacheAARCPinBar[idx].EqualsInput(input))
                        return cacheAARCPinBar[idx];

            lock (checkAARCPinBar)
            {
                checkAARCPinBar.Barcount = barcount;
                barcount = checkAARCPinBar.Barcount;
                checkAARCPinBar.Bearpintext = bearpintext;
                bearpintext = checkAARCPinBar.Bearpintext;
                checkAARCPinBar.Bodysize = bodysize;
                bodysize = checkAARCPinBar.Bodysize;
                checkAARCPinBar.Bullpintext = bullpintext;
                bullpintext = checkAARCPinBar.Bullpintext;
                checkAARCPinBar.Seperation = seperation;
                seperation = checkAARCPinBar.Seperation;
                checkAARCPinBar.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkAARCPinBar.Thistimeperiodon;
                checkAARCPinBar.TimeperiodA = timeperiodA;
                timeperiodA = checkAARCPinBar.TimeperiodA;
                checkAARCPinBar.TimeperiodB = timeperiodB;
                timeperiodB = checkAARCPinBar.TimeperiodB;
                checkAARCPinBar.Timeperiodon = timeperiodon;
                timeperiodon = checkAARCPinBar.Timeperiodon;
                checkAARCPinBar.Wordingon = wordingon;
                wordingon = checkAARCPinBar.Wordingon;
                checkAARCPinBar.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCPinBar.Zzstrategyuse;

                if (cacheAARCPinBar != null)
                    for (int idx = 0; idx < cacheAARCPinBar.Length; idx++)
                        if (cacheAARCPinBar[idx].Barcount == barcount && cacheAARCPinBar[idx].Bearpintext == bearpintext && Math.Abs(cacheAARCPinBar[idx].Bodysize - bodysize) <= double.Epsilon && cacheAARCPinBar[idx].Bullpintext == bullpintext && cacheAARCPinBar[idx].Seperation == seperation && cacheAARCPinBar[idx].Thistimeperiodon == thistimeperiodon && cacheAARCPinBar[idx].TimeperiodA == timeperiodA && cacheAARCPinBar[idx].TimeperiodB == timeperiodB && cacheAARCPinBar[idx].Timeperiodon == timeperiodon && cacheAARCPinBar[idx].Wordingon == wordingon && cacheAARCPinBar[idx].Zzstrategyuse == zzstrategyuse && cacheAARCPinBar[idx].EqualsInput(input))
                            return cacheAARCPinBar[idx];

                AARCPinBar indicator = new AARCPinBar();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Barcount = barcount;
                indicator.Bearpintext = bearpintext;
                indicator.Bodysize = bodysize;
                indicator.Bullpintext = bullpintext;
                indicator.Seperation = seperation;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeperiodA = timeperiodA;
                indicator.TimeperiodB = timeperiodB;
                indicator.Timeperiodon = timeperiodon;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCPinBar[] tmp = new AARCPinBar[cacheAARCPinBar == null ? 1 : cacheAARCPinBar.Length + 1];
                if (cacheAARCPinBar != null)
                    cacheAARCPinBar.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCPinBar = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public AARCRetracer AARCRetracer(int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return AARCRetracer(Input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public AARCRetracer AARCRetracer(Data.IDataSeries input, int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            if (cacheAARCRetracer != null)
                for (int idx = 0; idx < cacheAARCRetracer.Length; idx++)
                    if (cacheAARCRetracer[idx].Counter == counter && cacheAARCRetracer[idx].ReTracetext == reTracetext && cacheAARCRetracer[idx].Seperation == seperation && cacheAARCRetracer[idx].Trend == trend && cacheAARCRetracer[idx].Wordingon == wordingon && cacheAARCRetracer[idx].Zzstrategyuse == zzstrategyuse && cacheAARCRetracer[idx].EqualsInput(input))
                        return cacheAARCRetracer[idx];

            lock (checkAARCRetracer)
            {
                checkAARCRetracer.Counter = counter;
                counter = checkAARCRetracer.Counter;
                checkAARCRetracer.ReTracetext = reTracetext;
                reTracetext = checkAARCRetracer.ReTracetext;
                checkAARCRetracer.Seperation = seperation;
                seperation = checkAARCRetracer.Seperation;
                checkAARCRetracer.Trend = trend;
                trend = checkAARCRetracer.Trend;
                checkAARCRetracer.Wordingon = wordingon;
                wordingon = checkAARCRetracer.Wordingon;
                checkAARCRetracer.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCRetracer.Zzstrategyuse;

                if (cacheAARCRetracer != null)
                    for (int idx = 0; idx < cacheAARCRetracer.Length; idx++)
                        if (cacheAARCRetracer[idx].Counter == counter && cacheAARCRetracer[idx].ReTracetext == reTracetext && cacheAARCRetracer[idx].Seperation == seperation && cacheAARCRetracer[idx].Trend == trend && cacheAARCRetracer[idx].Wordingon == wordingon && cacheAARCRetracer[idx].Zzstrategyuse == zzstrategyuse && cacheAARCRetracer[idx].EqualsInput(input))
                            return cacheAARCRetracer[idx];

                AARCRetracer indicator = new AARCRetracer();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Counter = counter;
                indicator.ReTracetext = reTracetext;
                indicator.Seperation = seperation;
                indicator.Trend = trend;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCRetracer[] tmp = new AARCRetracer[cacheAARCRetracer == null ? 1 : cacheAARCRetracer.Length + 1];
                if (cacheAARCRetracer != null)
                    cacheAARCRetracer.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCRetracer = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public AARCSQ1001 AARCSQ1001(int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return AARCSQ1001(Input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public AARCSQ1001 AARCSQ1001(Data.IDataSeries input, int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            if (cacheAARCSQ1001 != null)
                for (int idx = 0; idx < cacheAARCSQ1001.Length; idx++)
                    if (cacheAARCSQ1001[idx].Ema1 == ema1 && cacheAARCSQ1001[idx].Entry == entry && cacheAARCSQ1001[idx].Exit == exit && cacheAARCSQ1001[idx].Seperation == seperation && cacheAARCSQ1001[idx].Trend == trend && Math.Abs(cacheAARCSQ1001[idx].Zone - zone) <= double.Epsilon && cacheAARCSQ1001[idx].Zstrategyuse == zstrategyuse && cacheAARCSQ1001[idx].EqualsInput(input))
                        return cacheAARCSQ1001[idx];

            lock (checkAARCSQ1001)
            {
                checkAARCSQ1001.Ema1 = ema1;
                ema1 = checkAARCSQ1001.Ema1;
                checkAARCSQ1001.Entry = entry;
                entry = checkAARCSQ1001.Entry;
                checkAARCSQ1001.Exit = exit;
                exit = checkAARCSQ1001.Exit;
                checkAARCSQ1001.Seperation = seperation;
                seperation = checkAARCSQ1001.Seperation;
                checkAARCSQ1001.Trend = trend;
                trend = checkAARCSQ1001.Trend;
                checkAARCSQ1001.Zone = zone;
                zone = checkAARCSQ1001.Zone;
                checkAARCSQ1001.Zstrategyuse = zstrategyuse;
                zstrategyuse = checkAARCSQ1001.Zstrategyuse;

                if (cacheAARCSQ1001 != null)
                    for (int idx = 0; idx < cacheAARCSQ1001.Length; idx++)
                        if (cacheAARCSQ1001[idx].Ema1 == ema1 && cacheAARCSQ1001[idx].Entry == entry && cacheAARCSQ1001[idx].Exit == exit && cacheAARCSQ1001[idx].Seperation == seperation && cacheAARCSQ1001[idx].Trend == trend && Math.Abs(cacheAARCSQ1001[idx].Zone - zone) <= double.Epsilon && cacheAARCSQ1001[idx].Zstrategyuse == zstrategyuse && cacheAARCSQ1001[idx].EqualsInput(input))
                            return cacheAARCSQ1001[idx];

                AARCSQ1001 indicator = new AARCSQ1001();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Ema1 = ema1;
                indicator.Entry = entry;
                indicator.Exit = exit;
                indicator.Seperation = seperation;
                indicator.Trend = trend;
                indicator.Zone = zone;
                indicator.Zstrategyuse = zstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCSQ1001[] tmp = new AARCSQ1001[cacheAARCSQ1001 == null ? 1 : cacheAARCSQ1001.Length + 1];
                if (cacheAARCSQ1001 != null)
                    cacheAARCSQ1001.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCSQ1001 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public AARCTimeOfDay AARCTimeOfDay(int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return AARCTimeOfDay(Input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public AARCTimeOfDay AARCTimeOfDay(Data.IDataSeries input, int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            if (cacheAARCTimeOfDay != null)
                for (int idx = 0; idx < cacheAARCTimeOfDay.Length; idx++)
                    if (cacheAARCTimeOfDay[idx].Apenw == apenw && cacheAARCTimeOfDay[idx].Bz1 == bz1 && cacheAARCTimeOfDay[idx].Bz2 == bz2 && cacheAARCTimeOfDay[idx].D1Buy1 == d1Buy1 && cacheAARCTimeOfDay[idx].D1Buy2 == d1Buy2 && cacheAARCTimeOfDay[idx].D1Sell1 == d1Sell1 && cacheAARCTimeOfDay[idx].D1Sell2 == d1Sell2 && cacheAARCTimeOfDay[idx].D2Buy1 == d2Buy1 && cacheAARCTimeOfDay[idx].D2Buy2 == d2Buy2 && cacheAARCTimeOfDay[idx].D2Sell1 == d2Sell1 && cacheAARCTimeOfDay[idx].D2Sell2 == d2Sell2 && cacheAARCTimeOfDay[idx].D3Buy1 == d3Buy1 && cacheAARCTimeOfDay[idx].D3Buy2 == d3Buy2 && cacheAARCTimeOfDay[idx].D3Sell1 == d3Sell1 && cacheAARCTimeOfDay[idx].D3Sell2 == d3Sell2 && cacheAARCTimeOfDay[idx].D4Buy1 == d4Buy1 && cacheAARCTimeOfDay[idx].D4Buy2 == d4Buy2 && cacheAARCTimeOfDay[idx].D4Sell1 == d4Sell1 && cacheAARCTimeOfDay[idx].D4Sell2 == d4Sell2 && cacheAARCTimeOfDay[idx].D5Buy1 == d5Buy1 && cacheAARCTimeOfDay[idx].D5Buy2 == d5Buy2 && cacheAARCTimeOfDay[idx].D5Sell1 == d5Sell1 && cacheAARCTimeOfDay[idx].D5Sell2 == d5Sell2 && cacheAARCTimeOfDay[idx].D6Buy1 == d6Buy1 && cacheAARCTimeOfDay[idx].D6Buy2 == d6Buy2 && cacheAARCTimeOfDay[idx].D6Sell1 == d6Sell1 && cacheAARCTimeOfDay[idx].D6Sell2 == d6Sell2 && cacheAARCTimeOfDay[idx].D7Buy1 == d7Buy1 && cacheAARCTimeOfDay[idx].D7Buy2 == d7Buy2 && cacheAARCTimeOfDay[idx].D7Sell1 == d7Sell1 && cacheAARCTimeOfDay[idx].D7Sell2 == d7Sell2 && cacheAARCTimeOfDay[idx].Sz1 == sz1 && cacheAARCTimeOfDay[idx].Sz2 == sz2 && cacheAARCTimeOfDay[idx].Zone == zone && cacheAARCTimeOfDay[idx].Zseperation == zseperation && cacheAARCTimeOfDay[idx].Zzstrategyuse == zzstrategyuse && cacheAARCTimeOfDay[idx].EqualsInput(input))
                        return cacheAARCTimeOfDay[idx];

            lock (checkAARCTimeOfDay)
            {
                checkAARCTimeOfDay.Apenw = apenw;
                apenw = checkAARCTimeOfDay.Apenw;
                checkAARCTimeOfDay.Bz1 = bz1;
                bz1 = checkAARCTimeOfDay.Bz1;
                checkAARCTimeOfDay.Bz2 = bz2;
                bz2 = checkAARCTimeOfDay.Bz2;
                checkAARCTimeOfDay.D1Buy1 = d1Buy1;
                d1Buy1 = checkAARCTimeOfDay.D1Buy1;
                checkAARCTimeOfDay.D1Buy2 = d1Buy2;
                d1Buy2 = checkAARCTimeOfDay.D1Buy2;
                checkAARCTimeOfDay.D1Sell1 = d1Sell1;
                d1Sell1 = checkAARCTimeOfDay.D1Sell1;
                checkAARCTimeOfDay.D1Sell2 = d1Sell2;
                d1Sell2 = checkAARCTimeOfDay.D1Sell2;
                checkAARCTimeOfDay.D2Buy1 = d2Buy1;
                d2Buy1 = checkAARCTimeOfDay.D2Buy1;
                checkAARCTimeOfDay.D2Buy2 = d2Buy2;
                d2Buy2 = checkAARCTimeOfDay.D2Buy2;
                checkAARCTimeOfDay.D2Sell1 = d2Sell1;
                d2Sell1 = checkAARCTimeOfDay.D2Sell1;
                checkAARCTimeOfDay.D2Sell2 = d2Sell2;
                d2Sell2 = checkAARCTimeOfDay.D2Sell2;
                checkAARCTimeOfDay.D3Buy1 = d3Buy1;
                d3Buy1 = checkAARCTimeOfDay.D3Buy1;
                checkAARCTimeOfDay.D3Buy2 = d3Buy2;
                d3Buy2 = checkAARCTimeOfDay.D3Buy2;
                checkAARCTimeOfDay.D3Sell1 = d3Sell1;
                d3Sell1 = checkAARCTimeOfDay.D3Sell1;
                checkAARCTimeOfDay.D3Sell2 = d3Sell2;
                d3Sell2 = checkAARCTimeOfDay.D3Sell2;
                checkAARCTimeOfDay.D4Buy1 = d4Buy1;
                d4Buy1 = checkAARCTimeOfDay.D4Buy1;
                checkAARCTimeOfDay.D4Buy2 = d4Buy2;
                d4Buy2 = checkAARCTimeOfDay.D4Buy2;
                checkAARCTimeOfDay.D4Sell1 = d4Sell1;
                d4Sell1 = checkAARCTimeOfDay.D4Sell1;
                checkAARCTimeOfDay.D4Sell2 = d4Sell2;
                d4Sell2 = checkAARCTimeOfDay.D4Sell2;
                checkAARCTimeOfDay.D5Buy1 = d5Buy1;
                d5Buy1 = checkAARCTimeOfDay.D5Buy1;
                checkAARCTimeOfDay.D5Buy2 = d5Buy2;
                d5Buy2 = checkAARCTimeOfDay.D5Buy2;
                checkAARCTimeOfDay.D5Sell1 = d5Sell1;
                d5Sell1 = checkAARCTimeOfDay.D5Sell1;
                checkAARCTimeOfDay.D5Sell2 = d5Sell2;
                d5Sell2 = checkAARCTimeOfDay.D5Sell2;
                checkAARCTimeOfDay.D6Buy1 = d6Buy1;
                d6Buy1 = checkAARCTimeOfDay.D6Buy1;
                checkAARCTimeOfDay.D6Buy2 = d6Buy2;
                d6Buy2 = checkAARCTimeOfDay.D6Buy2;
                checkAARCTimeOfDay.D6Sell1 = d6Sell1;
                d6Sell1 = checkAARCTimeOfDay.D6Sell1;
                checkAARCTimeOfDay.D6Sell2 = d6Sell2;
                d6Sell2 = checkAARCTimeOfDay.D6Sell2;
                checkAARCTimeOfDay.D7Buy1 = d7Buy1;
                d7Buy1 = checkAARCTimeOfDay.D7Buy1;
                checkAARCTimeOfDay.D7Buy2 = d7Buy2;
                d7Buy2 = checkAARCTimeOfDay.D7Buy2;
                checkAARCTimeOfDay.D7Sell1 = d7Sell1;
                d7Sell1 = checkAARCTimeOfDay.D7Sell1;
                checkAARCTimeOfDay.D7Sell2 = d7Sell2;
                d7Sell2 = checkAARCTimeOfDay.D7Sell2;
                checkAARCTimeOfDay.Sz1 = sz1;
                sz1 = checkAARCTimeOfDay.Sz1;
                checkAARCTimeOfDay.Sz2 = sz2;
                sz2 = checkAARCTimeOfDay.Sz2;
                checkAARCTimeOfDay.Zone = zone;
                zone = checkAARCTimeOfDay.Zone;
                checkAARCTimeOfDay.Zseperation = zseperation;
                zseperation = checkAARCTimeOfDay.Zseperation;
                checkAARCTimeOfDay.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCTimeOfDay.Zzstrategyuse;

                if (cacheAARCTimeOfDay != null)
                    for (int idx = 0; idx < cacheAARCTimeOfDay.Length; idx++)
                        if (cacheAARCTimeOfDay[idx].Apenw == apenw && cacheAARCTimeOfDay[idx].Bz1 == bz1 && cacheAARCTimeOfDay[idx].Bz2 == bz2 && cacheAARCTimeOfDay[idx].D1Buy1 == d1Buy1 && cacheAARCTimeOfDay[idx].D1Buy2 == d1Buy2 && cacheAARCTimeOfDay[idx].D1Sell1 == d1Sell1 && cacheAARCTimeOfDay[idx].D1Sell2 == d1Sell2 && cacheAARCTimeOfDay[idx].D2Buy1 == d2Buy1 && cacheAARCTimeOfDay[idx].D2Buy2 == d2Buy2 && cacheAARCTimeOfDay[idx].D2Sell1 == d2Sell1 && cacheAARCTimeOfDay[idx].D2Sell2 == d2Sell2 && cacheAARCTimeOfDay[idx].D3Buy1 == d3Buy1 && cacheAARCTimeOfDay[idx].D3Buy2 == d3Buy2 && cacheAARCTimeOfDay[idx].D3Sell1 == d3Sell1 && cacheAARCTimeOfDay[idx].D3Sell2 == d3Sell2 && cacheAARCTimeOfDay[idx].D4Buy1 == d4Buy1 && cacheAARCTimeOfDay[idx].D4Buy2 == d4Buy2 && cacheAARCTimeOfDay[idx].D4Sell1 == d4Sell1 && cacheAARCTimeOfDay[idx].D4Sell2 == d4Sell2 && cacheAARCTimeOfDay[idx].D5Buy1 == d5Buy1 && cacheAARCTimeOfDay[idx].D5Buy2 == d5Buy2 && cacheAARCTimeOfDay[idx].D5Sell1 == d5Sell1 && cacheAARCTimeOfDay[idx].D5Sell2 == d5Sell2 && cacheAARCTimeOfDay[idx].D6Buy1 == d6Buy1 && cacheAARCTimeOfDay[idx].D6Buy2 == d6Buy2 && cacheAARCTimeOfDay[idx].D6Sell1 == d6Sell1 && cacheAARCTimeOfDay[idx].D6Sell2 == d6Sell2 && cacheAARCTimeOfDay[idx].D7Buy1 == d7Buy1 && cacheAARCTimeOfDay[idx].D7Buy2 == d7Buy2 && cacheAARCTimeOfDay[idx].D7Sell1 == d7Sell1 && cacheAARCTimeOfDay[idx].D7Sell2 == d7Sell2 && cacheAARCTimeOfDay[idx].Sz1 == sz1 && cacheAARCTimeOfDay[idx].Sz2 == sz2 && cacheAARCTimeOfDay[idx].Zone == zone && cacheAARCTimeOfDay[idx].Zseperation == zseperation && cacheAARCTimeOfDay[idx].Zzstrategyuse == zzstrategyuse && cacheAARCTimeOfDay[idx].EqualsInput(input))
                            return cacheAARCTimeOfDay[idx];

                AARCTimeOfDay indicator = new AARCTimeOfDay();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Apenw = apenw;
                indicator.Bz1 = bz1;
                indicator.Bz2 = bz2;
                indicator.D1Buy1 = d1Buy1;
                indicator.D1Buy2 = d1Buy2;
                indicator.D1Sell1 = d1Sell1;
                indicator.D1Sell2 = d1Sell2;
                indicator.D2Buy1 = d2Buy1;
                indicator.D2Buy2 = d2Buy2;
                indicator.D2Sell1 = d2Sell1;
                indicator.D2Sell2 = d2Sell2;
                indicator.D3Buy1 = d3Buy1;
                indicator.D3Buy2 = d3Buy2;
                indicator.D3Sell1 = d3Sell1;
                indicator.D3Sell2 = d3Sell2;
                indicator.D4Buy1 = d4Buy1;
                indicator.D4Buy2 = d4Buy2;
                indicator.D4Sell1 = d4Sell1;
                indicator.D4Sell2 = d4Sell2;
                indicator.D5Buy1 = d5Buy1;
                indicator.D5Buy2 = d5Buy2;
                indicator.D5Sell1 = d5Sell1;
                indicator.D5Sell2 = d5Sell2;
                indicator.D6Buy1 = d6Buy1;
                indicator.D6Buy2 = d6Buy2;
                indicator.D6Sell1 = d6Sell1;
                indicator.D6Sell2 = d6Sell2;
                indicator.D7Buy1 = d7Buy1;
                indicator.D7Buy2 = d7Buy2;
                indicator.D7Sell1 = d7Sell1;
                indicator.D7Sell2 = d7Sell2;
                indicator.Sz1 = sz1;
                indicator.Sz2 = sz2;
                indicator.Zone = zone;
                indicator.Zseperation = zseperation;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCTimeOfDay[] tmp = new AARCTimeOfDay[cacheAARCTimeOfDay == null ? 1 : cacheAARCTimeOfDay.Length + 1];
                if (cacheAARCTimeOfDay != null)
                    cacheAARCTimeOfDay.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCTimeOfDay = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCBigBenda AARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.AARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCBigBenda AARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.AARCBigBenda(input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCDonchain AARCDonchain(int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return _indicator.AARCDonchain(Input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCDonchain AARCDonchain(Data.IDataSeries input, int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return _indicator.AARCDonchain(input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCEmafan AARCEmafan(int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return _indicator.AARCEmafan(Input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCEmafan AARCEmafan(Data.IDataSeries input, int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return _indicator.AARCEmafan(input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCMacDiv AARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCMacDiv AARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCMacDiv(input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCNR10 AARCNR10(string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return _indicator.AARCNR10(Input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCNR10 AARCNR10(Data.IDataSeries input, string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return _indicator.AARCNR10(input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCPinBar AARCPinBar(int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCPinBar(Input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCPinBar AARCPinBar(Data.IDataSeries input, int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCPinBar(input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCRetracer AARCRetracer(int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCRetracer(Input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCRetracer AARCRetracer(Data.IDataSeries input, int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCRetracer(input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCSQ1001 AARCSQ1001(int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return _indicator.AARCSQ1001(Input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCSQ1001 AARCSQ1001(Data.IDataSeries input, int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return _indicator.AARCSQ1001(input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCTimeOfDay AARCTimeOfDay(int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return _indicator.AARCTimeOfDay(Input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCTimeOfDay AARCTimeOfDay(Data.IDataSeries input, int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return _indicator.AARCTimeOfDay(input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCBigBenda AARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.AARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCBigBenda AARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCBigBenda(input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCDonchain AARCDonchain(int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return _indicator.AARCDonchain(Input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCDonchain AARCDonchain(Data.IDataSeries input, int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCDonchain(input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCEmafan AARCEmafan(int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return _indicator.AARCEmafan(Input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCEmafan AARCEmafan(Data.IDataSeries input, int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCEmafan(input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCMacDiv AARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCMacDiv AARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCMacDiv(input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCNR10 AARCNR10(string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return _indicator.AARCNR10(Input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCNR10 AARCNR10(Data.IDataSeries input, string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCNR10(input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCPinBar AARCPinBar(int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCPinBar(Input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCPinBar AARCPinBar(Data.IDataSeries input, int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCPinBar(input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCRetracer AARCRetracer(int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCRetracer(Input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCRetracer AARCRetracer(Data.IDataSeries input, int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCRetracer(input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCSQ1001 AARCSQ1001(int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return _indicator.AARCSQ1001(Input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCSQ1001 AARCSQ1001(Data.IDataSeries input, int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCSQ1001(input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCTimeOfDay AARCTimeOfDay(int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return _indicator.AARCTimeOfDay(Input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCTimeOfDay AARCTimeOfDay(Data.IDataSeries input, int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCTimeOfDay(input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }
    }
}
#endregion
